
\name{
getGnumericWorkbook
}

\alias{
getGnumericWorkbook
}

\title{
Get parent Workbook of a Sheet.
}

\description{
 
This function retrieves a reference to the
Workbook in which the sheet is contained. This
can be used to create new sheets and access others
in the workbook.

}

\usage{
getGnumericWorkbook
(
.sheet
)
}

\arguments{
 \item{
.sheet
}{
   

The Gnumeric sheet object of class
 GnumericSheetRef.  This is usually available as an
 argument to the S function invoked by the Gnumeric sheet.


 }
}

\details{
This accesses the internal structure of
the Sheet instance and computes the parent
workbook. 
}

\value{}

\references{}

\author{Duncan Temple Langduncan@research.bell-labs.com
\url{http://cm.bell-labs.com/stat/duncan}
}

\note{}

\seealso{
\code{\link{length.GnumericWorkbookRef}}

\code{\link{[.GnumericWorkbookRef}}

\code{\link{names.GnumericWorkbookRef}}

\code{\link{uniqueSheetName}}

\code{\link{recalcBook}}
}

\examples{
   
We might use this for removing a sheet each time 

gnumeric.registerFunction(function(.sheet){ 
                           w <- getGnumericWorkbook(.sheet)
                           if(w["output"])
                                removeSheet(w["output"])
                           T
                          }, "removeSheet", "", "", "check removal of a sheet")

}

\keyword{ 
spreadsheet
}

\keyword{ 
inter-system interface
}
